# $Id: wxRemAbout.py 8 2006-05-08 15:14:25Z dag $
import os.path, wx, datetime, re
import wx.html as html
from wxremdata import RemData, SlotList, HourBar, MarkInterval

marker_resolution = 'low'
days_view = 'fd'
dayfontadj = '-1'

from wxremindrc import *
from version import *

class Days(wx.Frame):
    def __init__(self, parent, y, m, d):
        wx.Frame.__init__(self, parent, -1, 'wxRemind: %d day agenda' % days, size=(480,700))
        self.html = html.HtmlWindow(self, -1)
        self.html.SetBackgroundColour(fcolor)


        self.box = wx.BoxSizer(wx.VERTICAL)
        self.box.Add(self.html, 1, wx.EXPAND | wx.ALL, 4 )

        subbox = wx.BoxSizer(wx.HORIZONTAL)

        self.printer = html.HtmlEasyPrinting()
        btn = wx.Button(self, -1, "Print")
        self.Bind(wx.EVT_BUTTON, self.OnPrint, btn)
        subbox.Add(btn, 1, wx.ALIGN_CENTRE | wx.LEFT | wx.RIGHT, 12)

        btn = wx.Button(self, wx.ID_OK, "Close")
        btn.SetDefault()
        subbox.Add(btn, 1, wx.ALIGN_CENTRE | wx.RIGHT, 24)
        self.Bind(wx.EVT_BUTTON, self.OnQuit, btn)

        self.box.Add(subbox, 0, wx.EXPAND)

        self.SetSizer(self.box)
        self.SetAutoLayout(True)
        self.ShowDays(y,m,d)

    def ShowDays(self, y,m,d):
        date = datetime.date(int(y),int(m),int(d))
        mydata = RemData()
        mydata.getMonths()
        count = 0
        startdate = date
        daystr = ""
        fblist = []
        while count < days:
            fb = SlotList() # populate a free busy list for the day
            y, m, d = date.strftime("%Y %m %d").split()
            count += 1
            state = {}
            shortdaystr = "%s" % date.strftime("%d %a")
            if mydata.getDay(y,m,d) != None:
                daystr += '<tr><td colspan="2" align="left"><b><font color="%s">%s:</font></b></td></tr>\n' % (todaycolor, date.strftime("%a, %d %b"))
                for event in mydata.getDay(y,m,d):
                    if event[7] != "*" and event[6] != "*":
                        MarkInterval(fb, state, event[6], event[7])
                    tcol = "&nbsp;"
                    if event[0] != "": tcol += event[0]
                    if event[2] != "": tcol += "-%s" % event[2]
                    mcol = ' '.join(event[3:-6])
                    daystr += "<tr><td>%s</td><td>%s</td></tr>\n" % (tcol,
                     mcol)
                # daystr += '<tr><td colspan="2"><hr></td></tr>\n'
                daystr += '<tr><td colspan="2"> &nbsp; </td></tr>\n'
            enddate = date
            date = date + RemData.oneday
            fblist.append("%s %s" % (shortdaystr, ''.join(fb)))
        if startdate == enddate:
            title = " %s " % startdate.strftime("%a, %d %b %Y") 
        else:
            title = " %s - %s " % (
                startdate.strftime("%a, %d %b %Y"), 
                enddate.strftime("%a, %d %b %Y"))

        needstitle = True
        toshow = {}
        head = '<html>\n<body>\n<font size="%s">\n' % daysfontsize
        foot = '</font>\n</body>\n</html>'
        title = '<center><b><font size = "+1" color="%s">%s</font></b></center>' % (todaycolor, title)
        viewparts = []
        for i in range(len(days_view)):
            viewparts.append(days_view[i])
        if 'f' in viewparts:
            toshow['f'] = '''\n<pre><font color="%s" size="%s">%s
%s</font></pre>''' % (freebusycolor, daysfontsize, HourBar(), '\n'.join(fblist))

        if 'd' in viewparts:
#           toshow['d'] = '''\n<table width="100%%" border="0" cellpadding = "0" cellspacing = "0"  cols="4">
# <tr><td colspan="2"><hr></td></tr>
# %s</table>
# ''' % daystr
            toshow['d'] = '''\n<table width="100%%" border="0" cellpadding = "0" cellspacing = "0"  cols="4">
<tr><td colspan="2"> &nbsp; </td></tr>
%s</table>
''' % daystr

        self.text = head
        for s in viewparts:
            if (s == 'f' or s == 'd') and needstitle:
                self.text += title
                needstitle = False
            self.text += toshow[s]
        self.text += foot
        self.html.SetPage(self.text)


    def OnPrint(self, event):
        self.printer.GetPrintData().SetPaperId(wx.PAPER_LETTER)
        self.printer.PrintText(self.text)

    def OnQuit(self, event):
        self.Destroy()

