#!/usr/bin/env python
"""
wxremind.py

Copyright (c) 2006-2008 Daniel Graham <daniel.graham@duke.edu>. All rights 
reserved.

License:
This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version. [ http://www.gnu.org/licenses/gpl.html ]

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
"""
import os, os.path, shutil, re, codecs
# import time
import wx
import wx.calendar
import datetime
import tempfile
from dateutil import relativedelta as rd
from dateutil import rrule as rr
import linecache
import wx.lib.mixins.listctrl  as  listmix
# import wx.html as html

from wxremalert import Alert
from wxRemHelp import Help
from wxRemAbout import About
# from wxRemHints import Hints
# import wxRemHints

from wxRemDays import Days
# from wxremalert import alert as wxralert
import wxRemEdit
import textwrap
import locale
from math import ceil, floor


twl = textwrap.TextWrapper(width=116)
# print "wxPython: %s.%s.%s" % (wx.MAJOR_VERSION, wx.MINOR_VERSION, wx.RELEASE_NUMBER)

from version import *
from wxremindrc import *

wx.SetDefaultPyEncoding(encoding)

if ec_border == -1:
    BORDER = wx.SUNKEN_BORDER
elif ec_border == 0:
    BORDER = wx.NO_BORDER
elif ec_border == 1:
    BORDER = wx.RAISED_BORDER
elif ec_border == 2:
    BORDER = wx.SIMPLE_BORDER

# set the border styles
if sb_border == -1:
    SBORDER = wx.SB_NORMAL
elif sb_border == 0:
    SBORDER = wx.SB_FLAT
elif sb_border == 1:
    SBORDER = wx.SB_RAISED
elif sb_border == 2:
    SBORDER = wx.SIMPLE_BORDER

sb_string = "%s" % pressforhelp

# leadingzero = re.compile(r'(?<!(:|\d)) *0')
leadingzero = re.compile(r'(?<!(:|\d))0+(?=\d)')
# leadingzero = re.compile(r'\b0+(?=\d)')
holiday = re.compile(r'([0-9\/]+)\s+\*\s+HOLIDAY')
# 09:30:17
notepattern = re.compile(r'(NOTE\-\S+)')
beginbody = re.compile(r'\b(?=(MSG|MSF|RUN|CAL)\b)', re.IGNORECASE)


if twelvehour:
    tdyfmt = "%I:%M:%S%p %a, %b %d"
else:
    tdyfmt = "%H:%M:%S %a, %b %d"

# Prepare the replacment hash for later updating.
rephash = {'e' : editor, 'f' : None, 'n' : None,
    'y' : None, 'm' : None, 'd' : None}

# Since remind only recognizes English month abbreviations but python 
# gives the appropriate Locale version.
mnthabbrv = [
 'Jan',
 'Feb',
 'Mar',
 'Apr',
 'May',
 'Jun',
 'Jul',
 'Aug',
 'Sep',
 'Oct',
 'Nov',
 'Dec'
]

import wxremdata
Data = wxremdata.RemData()
cancel = 0

class MyBusyPanel(wx.Window):
    def __init__(self, parent):
        wx.Window.__init__(self, parent, -1, pos=(0,0), 
            size=(220,186), style = 0)
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        self.Bind(wx.EVT_ERASE_BACKGROUND, self.OnEraseBackground)
        self.Bind(wx.EVT_SIZE, self.OnSize)
        self.events = None

    def AcceptsFocus(*args, **kwargs):
        return False

    def OnSize(self, event):
        self.Refresh()

    def OnEraseBackground(self, event):
        pass 

    def SetEvents(self, events):
        self.events = events
        self.Refresh()

    def OnPaint(self, evt):
        pdc = wx.PaintDC(self)
        try:
            dc = wx.GCDC(pdc)
        except:
            dc = pdc
        # dc= wx.PaintDC(self)
        dc.SetBackground(wx.Brush(nfcolor))
        dc.SetFont(wx.Font(freebusyfontsize,wx.DEFAULT,wx.NORMAL,wx.NORMAL))
        dc.SetPen(wx.LIGHT_GREY_PEN)
        dc.Clear()

        top = 6
        left = 16
        w = 29

        for i  in range(0,15):
            j = top+12*i
            k = i+8
            if k%3 == 0:
                if k <= 12 or not twelvehour:
                    t = k
                else:
                    t = k-12
            else:
                t = ""
            dc.DrawLine(left,j,left+7*w,j)
            dc.DrawText('%+2s' % t, left-18, j-7)
        # Use the first two letters from locale's weekday abbreviations
        # wkdayabbr = [
            # locale.nl_langinfo(locale.ABDAY_1)[:2],
            # locale.nl_langinfo(locale.ABDAY_2)[:2],
            # locale.nl_langinfo(locale.ABDAY_3)[:2],
            # locale.nl_langinfo(locale.ABDAY_4)[:2],
            # locale.nl_langinfo(locale.ABDAY_5)[:2],
            # locale.nl_langinfo(locale.ABDAY_6)[:2],
            # locale.nl_langinfo(locale.ABDAY_7)[:2],
            # ]
        wkdayabbr = [
            locale.nl_langinfo(locale.ABDAY_1),
            locale.nl_langinfo(locale.ABDAY_2),
            locale.nl_langinfo(locale.ABDAY_3),
            locale.nl_langinfo(locale.ABDAY_4),
            locale.nl_langinfo(locale.ABDAY_5),
            locale.nl_langinfo(locale.ABDAY_6),
            locale.nl_langinfo(locale.ABDAY_7),
            ]
        if sundayfirst:
            d = wkdayabbr
        else:
            d = [
                wkdayabbr[1],
                wkdayabbr[2],
                wkdayabbr[3],
                wkdayabbr[4],
                wkdayabbr[5],
                wkdayabbr[6],
                wkdayabbr[0]
                ]
        for i  in range(0,8):
            j = left+w*i
            dc.DrawLine(j,top,j, 168+top)
        # for i in range(0,7):
            # j = 5+left+w*i
            # dc.DrawText('%+2s' % d[i], j, top-20)

        r, g, b = freebusycolor
        # r, g, b = (35, 142, 35)
        penclr   = wx.Colour(r, g, b, 128)
        brushclr = wx.Colour(r, g, b, 128)   # half transparent
        dc.SetPen(wx.Pen(penclr))
        dc.SetBrush(wx.Brush(brushclr))

        for e in self.events:
            if sundayfirst:
                day = e[0]
            else:
                if e[0] == 0:
                    day = 6
                else:
                    day = e[0]-1
            start = e[1]
            dur = e[2]
            x = left+w*int(day)
            # start and end minutes must belong to [8*60, 22*60]/5
            start_pos = int(floor(float(max(start, 8*60) - 8*60)/5.0))
            end_pos = int(ceil(float(min(start+dur, 22*60) - 8*60)/5.0))
            h = end_pos - start_pos
            y = top + start_pos
            self.rect = wx.Rect(0,0,w,h)
            pos = (x,y)
            self.rect.SetPosition(pos)
            dc.DrawRoundedRectangleRect(self.rect, 0)

class MyDateBar(wx.StaticText):
    # Keep it from taking the focus
    def AcceptsFocus(*args, **kwargs):
        return False


class MyDetailBar(wx.StaticText):
    # Keep it from taking the focus
    def AcceptsFocus(*args, **kwargs):
        return False

class MyTodayButton(wx.Button):
    def AcceptsFocus(*args, **kwargs):
        return False

class MyListCtrl(wx.ListView, listmix.ListCtrlAutoWidthMixin):
    def __init__(self, parent, ID, pos=wx.DefaultPosition,
                 size=wx.DefaultSize, style=0):
        wx.ListCtrl.__init__(self, parent, ID, pos, size, style)
        listmix.ListCtrlAutoWidthMixin.__init__(self)
    def AcceptsFocus(*args, **kwargs):
        return True

class MyCalCtrl(wx.calendar.CalendarCtrl):
    # Let the calendar take the focus
    def AcceptsFocus(*args, **kwargs):
        return True

class MyFrame(wx.Frame):
    def __init__(self):
        self.data = []
        self.actions = []
        self.calattr = []
        self.currentItem = 0
        self.currentCount = 0
        self.calfocus = 1
        self.lcfocus = 0
        self.sort = 'd'
        self.filter = 'a'
        fontfam = wx.DEFAULT
        self.PASTDAY = self.SELDAY = None
        self.ignore = []
        self.queued = ""
        # Turn off wxMacExecute Bad bundle messages
        nolog = wx.LogNull()


        bfont = wx.Font(basefontsize + buttonfontadj, fontfam,
                wx.NORMAL, wx.NORMAL)
        lfont = wx.Font(basefontsize + listfontadj, fontfam,
                wx.NORMAL, wx.NORMAL)
        dfont = wx.Font(basefontsize + datefontadj, fontfam,
                wx.NORMAL, wx.NORMAL)
        sfont = wx.Font(basefontsize + statusfontadj, fontfam,
                wx.NORMAL, wx.NORMAL)
        cfont = wx.Font(basefontsize + calendarfontadj, wx.DEFAULT,
                wx.NORMAL, wx.NORMAL)
        wx.Frame.__init__(self, None, -1, 'wxRemind')
        self.frame_id = self.GetId()

        # The top date bar
        self.datebar = MyDateBar(self, -1, "Test Date Bar", size=(-1,-1),
                style = wx.BORDER_NONE | wx.ST_NO_AUTORESIZE )
        self.datebar.SetFont(dfont)
        self.datebar_id = self.datebar.GetId()

        # The bottom (selected event details) bar
        self.detailbar = MyDetailBar(self, -1, "", size=(-1,-1),
                style = wx.NO_BORDER | wx.ST_NO_AUTORESIZE)
        self.detailbar.SetFont(sfont)
        self.detailbar_id = self.detailbar.GetId()

        # The today button
        self.tdy = MyTodayButton(self, -1, '', size=(-1,-1), style = wx.SB_FLAT)
        # self.tdy = wx.Button(self, -1, '', style = wx.SB_FLAT)
        self.tdy.SetFont(bfont)

        # For the time display on the today button
        self.OnTimer(None)
        self.Bind(wx.EVT_TIMER, self.OnTimer)
        self.timer = wx.Timer(self)
        self.timer.Start(1000)

        # For alerts
        self.process = None
        self.Bind(wx.EVT_IDLE, self.OnIdle)
        self.Bind(wx.EVT_END_PROCESS, self.OnProcessEnded)

        self.NOW = datetime.datetime.today()
        self.TODAY = datetime.date.today()
        st = self.NOW.strftime(tdyfmt)
        st = leadingzero.sub(' ', st)
        self.tdy.SetLabel(st)
        if not self.PASTDAY or self.PASTDAY != self.TODAY:
            Data.getMonths()
            self.PASTDAY = self.TODAY
        self.Bind(wx.EVT_TIMER, self.OnTimer)
        self.timer = wx.Timer(self)
        self.timer.Start(1000)

        self.Bind(wx.EVT_BUTTON, self.OnClick, self.tdy)
        self.tdy.Bind(wx.EVT_CHAR, self.OnChar)
        self.tdy.SetBackgroundColour(bgcolor)
        self.tdy.SetToolTipString("Jump to today.")
        self.tdy_id = self.tdy.GetId()

        # The event list
        self.lc = MyListCtrl(self, -1, size=(eventlistwidth, -1),
                style=wx.LC_REPORT | wx.LC_SINGLE_SEL
                | wx.LC_NO_HEADER | wx.WANTS_CHARS
                | BORDER )
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnItemSelected, self.lc)
        self.Bind(wx.EVT_LIST_ITEM_DESELECTED, self.OnItemDeSelected, self.lc)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.OnItemActivated, self.lc)
        self.lc.Bind(wx.EVT_CHAR, self.OnChar)
        self.lc.SetFont(lfont)
        self.lc.InsertColumn(0, '00:00AM')
        self.lc.InsertColumn(1, '-')
        self.lc.InsertColumn(2, '00:00PM')
        self.lc.InsertColumn(3, 'Message')
        self.lc.SetColumnWidth(0, -2)
        self.lc.SetColumnWidth(1, -2)
        self.lc.SetColumnWidth(2, -2)
        self.lc.SetColumnWidth(3, -1)
        self.lc_id = self.lc.GetId()
        if sundayfirst:
            self.cal = MyCalCtrl(self, -1, wx.DateTime_Now(), size = (-1,-1),
                    style = wx.calendar.CAL_SHOW_HOLIDAYS
                    | wx.calendar.CAL_SEQUENTIAL_MONTH_SELECTION
                    | BORDER
                    | wx.WANTS_CHARS
                    )
        else:
            self.cal = MyCalCtrl(self, -1, wx.DateTime_Now(), size = (-1,-1),
                    style = wx.calendar.CAL_SHOW_HOLIDAYS
                    | wx.calendar.CAL_SEQUENTIAL_MONTH_SELECTION
                    | wx.calendar.CAL_MONDAY_FIRST 
                    | BORDER
                    | wx.WANTS_CHARS
                    )
        self.cal.SetHeaderColours(headercolor,bgcolor)
        self.cal.SetHolidayColours(holidaycolor,bgcolor)
        self.cal.SetBackgroundColour(bgcolor)
        self.Bind(wx.calendar.EVT_CALENDAR_SEL_CHANGED, self.OnCalSelected,
                id=self.cal.GetId())
        self.cal.Bind(wx.EVT_SET_FOCUS, self.OnSetFocus)
        self.cal.Bind(wx.EVT_CHAR, self.OnChar)
        self.cal_id = self.cal.GetId()

        # The free/busy panel
        self.busy = MyBusyPanel(self)
        self.busy.SetBackgroundColour(nfcolor)

        # The layout
        vbox = wx.BoxSizer(wx.VERTICAL)

        hbox1 = wx.BoxSizer(wx.HORIZONTAL)
        vbox1 = wx.BoxSizer(wx.VERTICAL)
        vbox1.Add(self.tdy, 0, wx.ALIGN_CENTER | wx.TOP 
            | wx.LEFT | wx.BOTTOM, 8)
        vbox1.Add(self.cal, 0, wx.EXPAND | wx.ALIGN_CENTER | wx.LEFT, 16)
        vbox1.Add(self.busy, 0, wx.EXPAND | wx.ALIGN_TOP | wx.ALL, 6)
        vbox2 = wx.BoxSizer(wx.VERTICAL)
        vbox2.Add(self.datebar, 0, wx.EXPAND | wx.LEFT | wx.RIGHT | wx.TOP
            | wx.BOTTOM, 10)
        vbox2.Add(self.lc, 1, wx.EXPAND | wx.ALIGN_TOP | wx.LEFT | wx.RIGHT
            | wx.BOTTOM, 6)
        hbox1.Add(vbox1, 0, wx.EXPAND)
        hbox1.Add(vbox2, 0, wx.EXPAND)
        hbox2 = wx.BoxSizer(wx.HORIZONTAL)
        vbox3 = wx.BoxSizer(wx.VERTICAL)
        vbox3.Add(self.detailbar, -1, wx.EXPAND | wx.TOP | wx.LEFT | wx.RIGHT
            | wx.BOTTOM, 6)
        hbox2.Add(vbox3, -1, wx.EXPAND)
        vbox.Add(hbox1, -1, wx.EXPAND)
        vbox.Add(hbox2, 0, wx.EXPAND)
        self.SetSizerAndFit(vbox)
        width, height = self.GetSizeTuple()
        self.SetSizeHints(width, height, width, height)
        self.SetBackgroundColour(bgcolor)
        if remind_internal_server:
            self.StartProcess()
        # Show events for the current date.
        self.WEEKBEG = None
        self.Today()
        self.Focus('cal')

    def __del__(self):
        if self.process is not None:
            self.process.Detach()
            self.process.CloseOutput()
            self.process = None


    def StartProcess(self):
        self.process = wx.Process(self)
        self.process.Redirect();
        cmd = '%s -y -z0 %s' % (remind, reminders)
        pid = wx.Execute(cmd, wx.EXEC_ASYNC, self.process)

    def SendText(self, text):
        if self.process is not None:
            self.process.GetOutputStream().write(text + '\n')

    def CloseStream(self, evt):
        if self.process is not None:
            self.process.CloseOutput()

    def OnIdle(self, evt):
        if self.process is not None:
            stream = self.process.GetInputStream()
            if stream.CanRead():
                text = stream.read()
                parts = text.split()
                if len(parts) >=8  and parts[1] == 'reminder':
                    starttime, nowtime, tag = parts[2:5]
                    msg = " %s" % " ".join(parts[5:-2])
                    msg.strip()
                    if msg[1] != ignore_char:
                        if tag in self.ignore:
                            if starttime <= nowtime:
                                self.ignore.remove(tag)
                        else:
                            # cancel = 0
                            if starttime > nowtime:
                                dlg = Alert(self, alert_seconds, 1, tag, msg, self.ignore)
                                dlg.Show(True)
                                # dlg.ShowModal()
                            else:
                                dlg = Alert(self, final_seconds, 0, tag, msg, self.ignore)
                                dlg.Show(True)
                                # dlg.ShowModal()
                elif parts[1] == "newdate":
                    self.Today()
                elif parts[1] == "queued":
                    self.queued = "(%s queued reminders)" % parts[2]

    def OnProcessEnded(self, evt):
        if self.process is not None:
            stream = self.process.GetInputStream()
            if stream.CanRead():
                text = stream.read()
                print text
            self.process.Destroy()
            self.process = None

    def sortChoice(self, event):
        # pass
        tmp = event.GetString()
        self.sort = tmp[0]
        tmp = event.GetString()
        if tmp == 'all':
            f = 'n'
        else:
            f = tmp[0]
        self.filter = f

    def FormatDate(self,y,m,d):
        y,m,d = map(int, (y,m,d))
        date = datetime.date(y,m,d)
        st = date.strftime(dateformatstring)
        st = leadingzero.sub('', st)
        return st

    def FormatDateBar(self,y,m,d):
        y,m,d = map(int, (y,m,d))
        date = datetime.date(y,m,d)
        st = date.strftime(datebarformatstring)
        st = leadingzero.sub('', st, count=0)
        return st


    def OnTimer(self, evt):
        self.NOW = datetime.datetime.today()
        self.TODAY = datetime.date.today()
        st = self.NOW.strftime(tdyfmt)
        st = leadingzero.sub('', st)
        self.tdy.SetLabel(st)
        if not self.PASTDAY or self.PASTDAY != self.TODAY:
            Data.getMonths()
            self.PASTDAY = self.TODAY

    def OnClick(self, event):
        self.Today()

    def Today(self):
        if not self.TODAY:
            # reset data to show 'current date only' events today
            Data.getMonths()
        self.SELDAY = self.TODAY
        y,m,d = self.SELDAY.strftime("%Y %m %d").split()
        self.selday = (y,m,d)
        self.cal.SetDate(wx.DateTime_Now())
        self.showDay(self.selday[0], self.selday[1], self.selday[2])

    def OnMonthChange(self, y, m):
        y, m = map(int, (y,m))
        busy = Data.getMonthlyDurations(y,m)
        for i in range(1,32):
            attr = wx.calendar.CalendarDateAttr()
            self.cal.ResetAttr(i)
            attr.SetBackgroundColour(bgcolor)
            self.cal.SetAttr(i, attr)
        for day in busy.keys():
            minutes = busy[day]
            attr = wx.calendar.CalendarDateAttr()
            attr.SetBackgroundColour(bgcolor)
            if minutes >= 1600:
                attr.SetBorder(wx.calendar.CAL_BORDER_SQUARE)
                attr.SetBorderColour(holidaycolor)
                minutes -= 1600
            # else:
            if minutes < busy0[0]:
                attr.SetTextColour('BLACK')
            elif minutes < busy1[0]:
                attr.SetTextColour(busy0[1])
            elif minutes < busy2[0]:
                attr.SetTextColour(busy1[1])
            elif minutes < busy3[0]:
                attr.SetTextColour(busy2[1])
            elif minutes < busy4[0]:
                attr.SetTextColour(busy3[1])
            else:
                attr.SetTextColour(busy4[1])
            self.cal.SetAttr(day, attr)

    def OnCalSelected(self, event):
        y,m,d = event.GetDate().Format("%Y %m %d").split()
        self.showDay(y, m, d)


    def OnItemActivated(self, event):
        # Open the relevant file at the appropriate line number for editing.
        # only call editor if we have both a file and a line number
        if self.data[self.currentItem][3]:
            rephash['f'] = self.data[self.currentItem][4]
            rephash['n'] = self.data[self.currentItem][5]
            editlist = (editold % rephash).split()
            retval = os.spawnv(os.P_WAIT, editor, editlist)
            if retval > 0:
                self.infoMessage(
        'Attempt to start editor %s failed. Check setting in ~/.wxremindrc.' \
                % editor, 'Error', wx.ICON_ERROR)
            else:
                self.Refresh()


    def OnItemSelected(self, event):
        # Show the relevant reminder in the status bar.
        self.currentItem = event.m_itemIndex
        if self.data[self.currentItem][4]:
            file = self.data[self.currentItem][4]
            line = int(self.data[self.currentItem][5])
            reminder = linecache.getline(file,line).strip()
            if len(reminder) > 116:
                reminder = twl.wrap(reminder)[0] + " ..."
            self.detailbar.SetLabel(reminder)
            self.detailbar.Wrap(-1)
        self.Focus('lc')
        self.lc.EnsureVisible(self.currentItem)
        self.lc.SetItemState(self.currentItem,
            wx.LIST_STATE_SELECTED | wx.LIST_STATE_FOCUSED,
            wx.LIST_STATE_SELECTED )
        event.Skip()

    def OnItemDeSelected(self, event):
        self.currentItem = None
        self.detailbar.SetLabel("%s %s" % (sb_string, self.queued))

    def OnAbout(self, event):
        # show the about page
        About(self)


    def OnHelp(self, event):
        # show the help page
        dlg = Help(self)
        dlg.Show(True)


    def OnHints(self, event):
        # show the hints page
        os.system("wxremhints &")

    def OnDays(self):
        y,m,d = self.SELDAY.strftime("%Y %m %d").split()
        dlg = Days(self, y,m,d)
        dlg.Show(True)


    def OnMonth(self):
        # show the postscript calendar for the month
        m, y = self.SELDAY.strftime("%m %Y").split()
        date = "%s %s" % (mnthabbrv[int(m)-1], y)
        options = ""
        if not sundayfirst:
            options += " -pm"
        if not twelvehour:
            options += " -b1"
        cmd = "%s -p %s %s %s" % (remind, options, reminders, date)
        so = os.popen(cmd, 'r')
        lines = so.readlines()
        so.close()
        si = os.popen(rem2ps, 'w')
        for line in lines:
            si.write(line)
            hd = holiday.match(line)
            if hd:
                newline = "%s SHADE * * * %s\n" % (hd.group(1), holidayshade)
                si.write(newline)
        si.close() 
        # makecal = "%s -p %s %s %s | %s" \
        #           % (remind, options, reminders, date, rem2ps)
        # os.system("%s && %s" % (makecal, viewps))
        os.system(viewps)


    def OnSetFocus(self, event):
        # called by EVT_SET_FOCUS. sets bgcolor to match focus
        w = wx.Window_FindFocus()
        if w:
            curr_id = w.GetId()
            if curr_id == self.cal_id:
                self.Focus('cal')
            elif curr_id == self.lc_id:
                self.Focus('lc')
        event.Skip()

    def Focus(self, w=''):
        # Called with an argument sets appropriate focus, else toggles focus.
        if w == 'cal':
            self.setFocus('cal')
        elif w == 'lc':
            self.setFocus('lc')
        elif w == 'res':
            if self.calfocus:
                self.setFocus('cal')
            else:
                self.setFocus('lc')
        else:
            if self.calfocus:
                self.setFocus('lc')
            else:
                self.setFocus('cal')


    def setFocus(self, target):
        if target == 'cal':
            self.cal.SetFocus()
            self.calfocus = 1
            self.lcfocus = 0
            self.detailbar.SetLabel("%s %s" % (sb_string, self.queued))
            # self.cal.SetHeaderColours(headercolor,fcolor)
            # self.cal.SetBackgroundColour(fcolor)
            self.lc.SetBackgroundColour(nfcolor)
        elif target == 'lc':
            self.lc.SetFocus()
            self.lc.SetBackgroundColour(fcolor)
            # self.datebar.SetBackgroundColour(fcolor)
            self.lcfocus = 1
            self.calfocus = 0
            # self.cal.SetHeaderColours(headercolor,nfcolor)
            # self.cal.SetBackgroundColour(nfcolor)

    def showWeek(self, force=0):
        if sundayfirst:
            weekbeg = self.SELDAY + rd.relativedelta(weekday=rd.SU(-1))
            weekend = self.SELDAY + rd.relativedelta(weekday=rd.SA(+1))
        else:
            weekbeg = self.SELDAY + rd.relativedelta(weekday=rd.MO(-1))
            weekend = self.SELDAY + rd.relativedelta(weekday=rd.SU(+1))
        if not self.WEEKBEG or weekbeg != self.WEEKBEG or force:
            busy = []
            oneday = datetime.timedelta(days=1)
            self.WEEKBEG = weekbeg
            day = weekbeg
            while day <= weekend:
                y, m, d, w = map(int,day.strftime("%Y,%m,%d,%w").split(','))
                events = Data.getDay(y,m,d)
                if events:
                    for event in events:
                        if event[7] != "*" and event[6] != '*':
                            busy.append((w,event[7],event[6]))
                day = day + oneday
            self.busy.SetEvents(busy)

    def showDay(self,y,m,d):
        # Show the events for the specified day in the event list.
        y, m, d= map(int, (y,m,d))
        self.data = Data.getDay(y,m,d)
        if m != self.selday[1] or y != self.selday[0]:
            # the month has changed
            self.OnMonthChange(y,m)
        self.selday = (y,m,d)
        self.SELDAY = datetime.date(y,m,d)
        self.showWeek()
        self.lc.DeleteAllItems()
        if self.data:
            for i in range(len(self.data)):
                index = self.lc.InsertStringItem(i, self.data[i][0])
                self.lc.SetStringItem(index, 0, self.data[i][0])
                self.lc.SetStringItem(index, 1, self.data[i][1])
                self.lc.SetStringItem(index, 2, self.data[i][2])
                self.lc.SetStringItem(index, 3, self.data[i][3])
                self.lc.SetItemData(index, i)
                if self.data[i][9] and notepattern.match(self.data[i][9]):
                    item = self.lc.GetItem(i)
                    item.SetTextColour(notecolor)
                    self.lc.SetItem(item)
        # dayweeknumbers = True
        self.datebar.SetLabel("%s %s:" % (remindersfor,
            self.FormatDateBar(y,m,d)))
        if self.SELDAY == self.TODAY:
            self.datebar.SetForegroundColour(todaycolor)
        else:
            self.datebar.SetForegroundColour("BLACK")
        self.currentCount = self.lc.GetItemCount()
        self.Focus('cal')
        self.detailbar.SetLabel("%s %s" % (sb_string, self.queued))

    def OnChar(self, event):
        curr_id = self.FindFocus().GetId()
        keycode = event.GetKeyCode()
        if keycode == 9:            # tab
            self.Focus()
        elif keycode == 17:         # Ctrl-Q quit
            self.OnQuit()
        elif keycode == 32:         # space
            self.Today()
        elif keycode == 47:         # /: search
            self.OnSearch(event)
        elif keycode == 63:         # ? Show Help box
            self.OnHelp(event)
        elif keycode == 68:         # N Edit/Create note
            self.DeleteNote(event)
        elif keycode == 78:         # N Edit/Create note
            self.CreateOrEditNote(event)
        elif keycode == 82:         # R refresh
            self.Refresh()
        elif keycode == 97:         # a: alert event
            self.newEvent('a')
        elif keycode == 99:         # c show ps calendar for month
            self.OnMonth()
        elif keycode == 100:        # d show agenda for the next 'days'
            self.OnDays()
        elif keycode == 101:        # e: edit any event
            self.Edit(event)
        elif keycode == 104:        # h: show hints
            self.OnHints(event)
        elif keycode == 110:        # n: search next
            self.findNext(event)
        elif keycode == 115:        # s (skeleton event)
            self.newEvent('s')
        elif keycode == 116:        # t (timed event)
            self.newEvent('t')
        elif keycode == 117:        # u untimed event
            self.newEvent('u')
        elif keycode == wx.WXK_F1:  # F1 Show About box
            self.OnAbout(event)
        elif curr_id == self.lc_id:
            count = self.currentCount
            index = self.currentItem
            if keycode == 13:       # activate
                self.lc.Connect(-1,-1,
                    wx.wxEVT_COMMAND_LIST_ITEM_ACTIVATED,
                    self.OnItemActivated(index))
            if keycode == wx.WXK_UP and count:      # previous event
                new = max(0, index-1)
                self.lc.EnsureVisible(new)
                self.lc.SetItemState(new,
                    wx.LIST_STATE_SELECTED,
                    wx.LIST_STATE_SELECTED )
            elif keycode == wx.WXK_DOWN and count:      # next event
                new = min(count-1, index+1)
                self.lc.EnsureVisible(new)
                self.lc.SetItemState(new,
                    wx.LIST_STATE_SELECTED,
                    wx.LIST_STATE_SELECTED )
        else:
            event.Skip()


    def newEvent(self, type):
        # Create a new event and append it to the reminders file
        # count changes made to data before opening dialog
        changes = 0
        d, m, y = self.SELDAY.strftime("%d %m %Y").split()
        datefmt = "%s %s %s" % (d, mnthabbrv[int(m)-1], y)
        data = { "date" : datefmt, "dur" : defaultduration }
        changes += 1
        if type in ['a','t']:
            if alert_sound in (0,1,2):
                # this change doesn't affect the relevant count
                data["alert_s"] = int(alert_sound)
            if alert_display in (0,1,2):
                # this change doesn't affect the relevant count
                data["alert_d"] = int(alert_display)
            if alert_other_message:
                data["omsg"] = alert_other_message
                changes += 1
        dlg = wxRemEdit.MyDialog(data, type)
        dlg.UnsavedChanges -= changes
        # dlg.Show(True)
        dlg.ShowModal()
        dlg.Destroy()
        # dlg.EndModal(1)
        rem = None
        if data.has_key('msg') and data['msg'] != '':
            data['msg'] = u"%s" % data['msg']
            # user did not press cancel
            if type == 's':
                rem = "%(skel_r)s %(date)s %(skel_m)s %(msg)s" % data
            if data.has_key('dur') and data['dur']:
                data['dur'] = "DUR %s" % data['dur']
            else:
                data['dur'] = ''
            if data.has_key('omsg') and data['omsg']:
                data['msg'] = '%%"%s%%" %s' % (data['msg'], data['omsg'])
            else:
                data['msg'] = '%%"%s%%"' % data['msg']
            if type == 'a':
                # convert radio button index to switch string
                data['alert'] = '-d%s -s%s' % (data['alert_d'], data['alert_s'])
                rem = 'REM %(date)s AT %(time)s %(dur)s RUN wxremalert ' % data
                rem += '%(alert)s %(msg)s%%' % data
            elif type == 'u':
                rem = 'REM %(date)s MSG %(msg)s%%' % data
            elif type == 't':
                rem = 'REM %(date)s AT %(time)s %(dur)s MSG %(msg)s%%' % data
            if data.has_key('file_s'):
                filetouse = [current,reminders][data['file_s']]
            else:
                filetouse = reminders
        if rem:
            rephash['f'] = "%s" % filetouse
            # Backup the existing reminders file
            shutil.copyfile(filetouse, "%s.bak" % filetouse)
            remread = codecs.open(filetouse,'r', encoding)
            remlines = remread.readlines()
            remread.close()
            if len(remlines) > 0:
                # make sure the last line ends with a \n
                lastrem = remlines.pop().rstrip()
                lastrem = "%s\n" % lastrem
                remlines.append(lastrem)
            # append the new reminder
            remlines.append(rem)
            try:
                remwrite = codecs.open(filetouse, 'w', encoding)
                remwrite.writelines(remlines)
                remwrite.close()
            except:
                shutil.copyfile("%s.bak" % filetouse, filetouse)
                print "Error: could not record new reminder"
            self.Refresh()


    def Edit(self,evt):
        # Open the default reminders file at the last line for editing.
        rephash['f'] = "%s" % reminders
        rephash['n'] = -1
        editlist = (editnew % rephash).split()
        retval = os.spawnv(os.P_WAIT, editor, editlist)
        if retval > 0:
            self.infoMessage( 
            "Unable to edit using:\n     '%s'\nCheck setting in ~/.wxremindrc."\
             % editor,
            'Error', wx.ICON_ERROR)
        else:
            self.Refresh()

    def CreateOrEditNote(self, event):
        openeditor = False
        if self.lcfocus and self.data[self.currentItem][3]:
            remfile = self.data[self.currentItem][4]
            remline = int(self.data[self.currentItem][5])
        else:
            return False

        if self.data[self.currentItem][9]: # If the item has a tag 
            nm = notepattern.search(self.data[self.currentItem][9])
            if nm: # and it matches notepattern, open it for editing 
                notename = nm.group(1)
                notefile = os.path.join(notedir, notename)
                openeditor = True
            else: # there is a tag but it doesn't match notepattern
                self.infoMessage(
    "A tag already exists for this reminder but it doesn't appear to be a note." ,
                        'Tag exists', wx.ICON_INFORMATION)
        else: # there is no tag, so create a new notefile
            if self.okMessage(
                'Create a new note file for this reminder?', "Create note"):
                fd, notefile = tempfile.mkstemp(dir=notedir, prefix = "NOTE-", suffix = "",
                    text = True)
                os.close(fd)
                notename = os.path.basename(notefile.strip())
                self.InsertTag(remfile, remline, notename)
                self.Refresh()
                openeditor = True

        if openeditor:
            rephash['f'] = notefile
            rephash['n'] = 1
            editlist = (editold % rephash).split()
            retval = os.spawnv(os.P_WAIT, editor, editlist)
            if retval > 0:
                self.infoMessage(
        'Attempt to start editor %s failed. Check setting in ~/.wxremindrc.' \
                % editor, 'Error', wx.ICON_ERROR)

    def DeleteNote(self, event):
        # if the current item has a note tag delete the associated file
        # and remove the tag after asking for confirmation
        if self.lcfocus and self.data[self.currentItem][3]:
            file = self.data[self.currentItem][4]
            linenum = int(self.data[self.currentItem][5])
        else:
            return False
        if self.data[self.currentItem][9]: # If the item has a tag 
            nm = notepattern.search(self.data[self.currentItem][9])
            if nm: # and it matches notepattern 
                notename = nm.group(1)
                notefile = os.path.join(notedir, notename)
                if not os.path.isfile(notefile):
                    self.infoMessage(
                        "Unable to delete %s\nFile does not exist" % notefile,
                        'Error', wx.ICON_ERROR)
                elif self.okMessage(
    'Delete the note for this reminder?\nWarning: This action cannot be undone.',
    'Delete note'):
                    # delete the file
                    os.unlink(notefile)

                    # delete the tag
                    shutil.copyfile(file, "%s.bak" % file)
                    remread = codecs.open(file,'r', encoding)
                    remlines = remread.readlines()
                    remread.close()
                    origline = remlines[linenum - 1]
                    newline = re.sub(r'\bTAG\b\s+\S+ ', '', origline,
                        re.IGNORECASE)
                    # newline = beginbody.sub('TAG %s ' % tag, origline)
                    if newline != origline:
                        remlines[linenum - 1] = newline
                        try:
                            remwrite = codecs.open(file, 'w', encoding)
                            remwrite.writelines(remlines)
                            remwrite.close()
                        except:
                            # restore the original file
                            shutil.copyfile("%s.bak" % file, file)
                            print "Error: could not write modified file - restored originalfile"

                        self.Refresh()

    def InsertTag(self, file, linenum, tag):
        # first backup the relevant file
        shutil.copyfile(file, "%s.bak" % file)
        remread = codecs.open(file,'r', encoding)
        remlines = remread.readlines()
        remread.close()
        origline = remlines[linenum - 1]
        # newline = re.sub(r'\b(MSG|MSF|RUN|CAL)\b', 
        #   ' TAG %s \1' % tag, 
        #   origline,
        #   re.IGNORECASE)
        newline = beginbody.sub('TAG %s ' % tag, origline)
        if newline != origline:
            remlines[linenum - 1] = newline
            try:
                remwrite = codecs.open(file, 'w', encoding)
                remwrite.writelines(remlines)
                remwrite.close()
            except:
                # restore the original file
                shutil.copyfile("%s.bak" % file, file)
                print "Error: could not write modified file - restored originalfile"

    def Refresh(self):
        Data.getMonths()
        linecache.clearcache()
        self.OnMonthChange(self.selday[0], self.selday[1])
        self.showDay(self.selday[0], self.selday[1], self.selday[2])
        self.showWeek(force=1)
        self.SendText('REREAD')
        # self.SendText('STATUS')


    def OnSearch(self,evt):
        y,m,d = map(int, self.selday)
        Data.startdate = "%d %d %d" % (d, m, y)
        startingdate = self.SELDAY.strftime("%a, %d %b %Y")
        dlg = wx.TextEntryDialog(self, 
            'Begin a case-insensitive search for:',
            'Searching from %s' % startingdate,
            '')
        dlg.SetBackgroundColour(nfcolor)
        dlg.SetValue("")
        if dlg.ShowModal() == wx.ID_OK:
            str = dlg.GetValue()
            day = Data.firstOccurance(str.encode(encoding))
            if day:
                self.showDay(day[0],int(day[1]),int(day[2]))
                self.cal.SetDate( wx.DateTimeFromDMY(int(day[2]), 
                    int(day[1])-1, int(day[0])))
            else:
                self.notFound()
        dlg.Destroy()



    def findNext(self,evt):
        if Data.nextitem and Data.searchstr:
            day = Data.nextOccurance()
            if day:
                self.showDay(int(day[0]), int(day[1]), int(day[2]))
                self.cal.SetDate( wx.DateTimeFromDMY(int(day[2]),
                    int(day[1])-1, int(day[0])))
            else:
                self.notFound()
        else:
            self.OnSearch(evt)


    def notFound(self):
        year,month,day = Data.lastfound
        date = self.FormatDate(year, month, day)
        self.infoMessage("No occurances of '%s' were found after %s." %
                (Data.searchstr, date),
                'Failed Search', wx.ICON_INFORMATION)


    def infoMessage(self, message, title, icon):
        dlg = wx.MessageBox("%s" % message,
            caption = "%s" % title, style = wx.OK | icon)

    def okMessage(self, message, title):
        dlg = wx.MessageDialog(self, "%s" % message,
                                title,
                                wx.OK | wx.CANCEL | wx.ICON_INFORMATION
                                )
        if (dlg.ShowModal() == wx.ID_OK):
            return True
        else:
            return False
        dlg.Destroy()



    def OnQuit(self):
        self.timer.Stop()
        del self.timer
        self.Destroy()


class App(wx.App):
    def OnInit(self):
        import wx.lib.colourdb
        wx.lib.colourdb.updateColourDB()
        self.frame = MyFrame()
        self.frame.Show()
        self.SetTopWindow(self.frame)
        return True

def main():
    app = App()
    app.MainLoop()
